Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.shape/src/main/java/org/gvsig/exportto/swing/prov/shape/ExporttoShapeService.java	(revision 43920)
@@ -541,14 +543,15 @@
                         point.setCoordinateAt(2, 0);
                     }
                     line.addVertex(point);
-                };
+                }
+                ;
                 return line;
 
             case Geometry.TYPES.SURFACE:
             case Geometry.TYPES.POLYGON:
                 Polygon polygon = geoManager.createPolygon(Geometry.SUBTYPES.GEOM3D);
-                for (int i = 0; i < ((OrientablePrimitive)ge).getNumVertices(); i++) {
-                    Point vertex = ((OrientablePrimitive)ge).getVertex(i);
+                for (int i = 0; i < ((OrientablePrimitive) ge).getNumVertices(); i++) {
+                    Point vertex = ((OrientablePrimitive) ge).getVertex(i);
                     point = geoManager.createPoint(vertex.getX(), vertex.getY(), Geometry.SUBTYPES.GEOM3D);
                     try {
                         point.setCoordinateAt(2, vertex.getCoordinateAt(2));
@@ -556,40 +559,41 @@
                         point.setCoordinateAt(2, 0);
                     }
                     polygon.addVertex(point);
-                };
+                }
+                ;
                 return polygon;
             default:
                 return ge;
-            }
+        }
     }
-    private void createPoint(int geom3d) {
-        // TODO Auto-generated method stub
 
-    }
 
     /**
      * @param feature
      * @param edit_feat
      */
     private boolean setNonNulls(
-        FeatureType src_ft, FeatureType target_ft,
-        Feature feat, EditableFeature edit_f) {
+            FeatureType src_ft, 
+            FeatureType target_ft,
+            Feature feat, 
+            EditableFeature edit_f
+        ) {
 
         boolean error = false;
         FeatureAttributeDescriptor[] atts = src_ft.getAttributeDescriptors();
-        String orig_name = null;
-        String dbf_name = null;
-        for (int i=0; i<atts.length; i++) {
+        String orig_name;
+        String dbf_name;
+        for (int i = 0; i < atts.length; i++) {
             if (atts[i].getType() != org.gvsig.fmap.geom.DataTypes.GEOMETRY) {
 
                 Object val = null;
 
                 try {
-                	orig_name = atts[i].getName();
-                	dbf_name = this.nameTranslator.getTargetName(orig_name);
-                	if (dbf_name == null) {
-                		dbf_name = orig_name;
-                	}
+                    orig_name = atts[i].getName();
+                    dbf_name = this.nameTranslator.getTargetName(orig_name);
+                    if (dbf_name == null) {
+                        dbf_name = orig_name;
+                    }
                     val = feat.get(orig_name);
                     if (val != null) {
                         edit_f.set(dbf_name, val);
@@ -604,9 +608,9 @@
     }
 
     private Geometry union(List<Geometry> geoms)
-        throws GeometryOperationNotSupportedException, GeometryOperationException {
+            throws GeometryOperationNotSupportedException, GeometryOperationException {
 
-        if (geoms == null || geoms.size() == 0) {
+        if ( geoms == null || geoms.isEmpty()) {
             return null;
         }
 
@@ -615,11 +619,12 @@
         }
 
         Geometry resp = geoms.get(0);
-        for (int i=1; i<geoms.size(); i++) {
+        for (int i = 1; i < geoms.size(); i++) {
             resp = resp.union(geoms.get(i));
         }
         return resp;
     }
+
     /**
      * @param feat_geom_type
      * @param type must be POINT, LINE or POLYGON (Geometry.TYPES)
@@ -627,8 +632,8 @@
      */
     private List<Geometry> getGeometriesFrom(Geometry in_geom, int type) {
 
-        List<Geometry> resp = new ArrayList<Geometry>();
-        Aggregate agg = null;
+        List<Geometry> resp = new ArrayList<>();
+        Aggregate agg;
 
         /*
          * If input geometry is aggregate, search its
@@ -636,9 +641,9 @@
          */
         if (in_geom instanceof Aggregate) {
             agg = (Aggregate) in_geom;
-            Geometry item = null;
-            List<Geometry> add_parts = new ArrayList<Geometry>();
-            for (int i=0; i<agg.getPrimitivesNumber(); i++) {
+            Geometry item;
+            List<Geometry> add_parts = new ArrayList<>();
+            for (int i = 0; i < agg.getPrimitivesNumber(); i++) {
                 item = agg.getPrimitiveAt(i);
                 add_parts = getGeometriesFrom(item, type);
                 resp.addAll(add_parts);
@@ -647,32 +652,31 @@
         }
 
         // ============================================
-
         switch (type) {
-        case Geometry.TYPES.POINT:
-            if (in_geom instanceof Point) {
-                resp.add(in_geom);
-            }
-            // =======================================================
-            break;
-        case Geometry.TYPES.CURVE:
-            if (in_geom instanceof Curve) {
-                resp.add(in_geom);
-            }
-            // =======================================================
-            break;
-        case Geometry.TYPES.SURFACE:
-            if (in_geom instanceof Surface) {
-                resp.add(in_geom);
-            }
-            // =======================================================
-            break;
+            case Geometry.TYPES.POINT:
+                if (in_geom instanceof Point) {
+                    resp.add(in_geom);
+                }
+                // =======================================================
+                break;
+            case Geometry.TYPES.CURVE:
+                if (in_geom instanceof Curve) {
+                    resp.add(in_geom);
+                }
+                // =======================================================
+                break;
+            case Geometry.TYPES.SURFACE:
+                if (in_geom instanceof Surface) {
+                    resp.add(in_geom);
+                }
+                // =======================================================
+                break;
         }
         return resp;
     }
 
     private void finishAction(String layerName, File shp_file, IProjection proj)
-    throws ExporttoServiceException {
+            throws ExporttoServiceException {
 
         if (exporttoServiceFinishAction != null) {
 
@@ -680,11 +684,11 @@
              * Export is done. We notify with a SHPStoreParameters,
              * not with the NewSHPParameters we have used:
              */
-        	DataStoreParameters shp_params = null;
+            DataStoreParameters shp_params = null;
             try {
-	            shp_params = DALLocator.getDataManager().createStoreParameters("Shape");
-	            shp_params.setDynValue("shpfile", shp_file);
-	            shp_params.setDynValue("CRS", proj);
+                shp_params = DALLocator.getDataManager().createStoreParameters("Shape");
+                shp_params.setDynValue("shpfile", shp_file);
+                shp_params.setDynValue("CRS", proj);
 
                 shp_params.validate();
             } catch (Exception e) {
@@ -694,8 +698,9 @@
         }
     }
 
+    @Override
     public void setFinishAction(
-        ExporttoServiceFinishAction exporttoServiceFinishAction) {
+            ExporttoServiceFinishAction exporttoServiceFinishAction) {
         this.exporttoServiceFinishAction = exporttoServiceFinishAction;
     }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporttoJDBCOptions.java	(revision 43920)
@@ -6,16 +6,14 @@
 
 package org.gvsig.exportto.swing.prov.jdbc;
 
-import java.util.List;
-import org.cresques.cts.IProjection;
-import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.exportto.swing.spi.options.ExportGeometryOptions;
 import org.gvsig.fmap.dal.store.jdbc.JDBCServerExplorerParameters;
 
 /**
  *
  * @author jjdelcerro
  */
-public interface ExporttoJDBCOptions  {
+public interface ExporttoJDBCOptions  extends ExportGeometryOptions {
 
     public JDBCServerExplorerParameters getExplorerParameters();
     
@@ -27,26 +25,16 @@
     
     public String getPrimaryKey();
     
-    public int getGeometryChecks();
-    
-    public int getGeometryChecksAction();
-    
     public String getStoreName();
 
     public String getExplorerName();
     
-    public FeatureStore getSource();
-    
-    public boolean getTryToFixGeometry();
-
     public boolean getTranslateIdentifiersToLowerCase();
 
     public boolean getRemoveSpacesInIdentifiers();
     
     public boolean getTranslateHyphens();
     
-    public IProjection getTargetProjection();
-    
     public String getSelectRole();
     
     public String getInsertRole();
@@ -68,4 +56,110 @@
     public boolean getCreateIndexInGeometryRow();
     
     public boolean getUpdateTableStatistics();
+   
+
+    /**
+     * @param allRole the allRole to set
+     */
+    void setAllRole(String allRole);
+
+    /**
+     * @param canCreatetable the canCreatetable to set
+     */
+    void setCanCreatetable(boolean canCreatetable);
+
+    /**
+     * @param createIndexInGeometryRow the createIndexInGeometryRow to set
+     */
+    void setCreateIndexInGeometryRow(boolean createIndexInGeometryRow);
+
+    /**
+     * @param deleteRole the deleteRole to set
+     */
+    void setDeleteRole(String deleteRole);
+
+    /**
+     * @param explorerName the explorerName to set
+     */
+    void setExplorerName(String explorerName);
+
+    /**
+     * @param explorerParameters the explorerParameters to set
+     */
+    void setExplorerParameters(JDBCServerExplorerParameters explorerParameters);
+
+    /**
+     * @param insertRole the insertRole to set
+     */
+    void setInsertRole(String insertRole);
+
+    /**
+     * @param postCreatingStatement the postCreatingStatement to set
+     */
+    void setPostCreatingStatement(String postCreatingStatement);
+
+    /**
+     * @param primaryKey the primaryKey to set
+     */
+    void setPrimaryKey(String primaryKey);
+
+    /**
+     * @param referenceRole the referenceRole to set
+     */
+    void setReferenceRole(String referenceRole);
+
+    /**
+     * @param removeSpacesInIdentifiers the removeSpacesInIdentifiers to set
+     */
+    void setRemoveSpacesInIdentifiers(boolean removeSpacesInIdentifiers);
+
+    /**
+     * @param schema the schema to set
+     */
+    void setSchema(String schema);
+
+    /**
+     * @param selectRole the selectRole to set
+     */
+    void setSelectRole(String selectRole);
+
+    /**
+     * @param storeName the storeName to set
+     */
+    void setStoreName(String storeName);
+
+    /**
+     * @param tableName the tableName to set
+     */
+    void setTableName(String tableName);
+
+    /**
+     * @param translateHyphens the translateHyphens to set
+     */
+    void setTranslateHyphens(boolean translateHyphens);
+
+    /**
+     * @param translateIdentifiersToLowerCase the translateIdentifiersToLowerCase to set
+     */
+    void setTranslateIdentifiersToLowerCase(boolean translateIdentifiersToLowerCase);
+
+    /**
+     * @param triggerRole the triggerRole to set
+     */
+    void setTriggerRole(String triggerRole);
+
+    /**
+     * @param truncateRole the truncateRole to set
+     */
+    void setTruncateRole(String truncateRole);
+
+    /**
+     * @param updateRole the updateRole to set
+     */
+    void setUpdateRole(String updateRole);
+
+    /**
+     * @param updateTableStatistics the updateTableStatistics to set
+     */
+    void setUpdateTableStatistics(boolean updateTableStatistics);
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProviderFactory.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProviderFactory.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/BaseExporttoJDBCProviderFactory.java	(revision 43920)
@@ -25,7 +25,6 @@
 
 import java.util.Iterator;
 import java.util.List;
-import org.cresques.cts.IProjection;
 import org.gvsig.exportto.swing.ExporttoSwingManager;
 import org.gvsig.exportto.swing.spi.AbstractExporttoProviderFactory;
 import org.gvsig.fmap.dal.DALLocator;
@@ -57,15 +56,18 @@
             ExporttoSwingManager.VECTORIAL_TABLE_WITH_GEOMETRY});
     }
 
+    @Override
     public String getName() {
         return PROVIDER_NAME;
     }
 
+    @Override
     public String getDescription() {
         return Messages.getText("general_exporter_description",
                 new String[]{"DataBase (" + getConnectorNames() + " throws JDBC)"});
     }
 
+    @Override
     public String getLabel() {
         return Messages.getText("general_exporter_label",
                 new String[]{"DataBase (throws JDBC)"});
@@ -102,10 +104,12 @@
         }
     }
 
+    @Override
     public Provider create(DynObject parameters, ProviderServices services) throws ServiceException {
-        return new BaseExporttoJDBCProvider(services,
-                (FeatureStore) parameters.getDynValue(PARAMETER_FEATURESTORE),
-                (IProjection) parameters.getDynValue(PARAMETER_PROJECTION));
+        return new BaseExporttoJDBCProvider(
+                services,
+                (FeatureStore) parameters.getDynValue(PARAMETER_FEATURESTORE)
+        );
     }
 
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java	(revision 43919)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/ExporrtoJDBCService.java	(revision 43920)
@@ -29,9 +29,10 @@
 import org.gvsig.exportto.ExporttoService;
 import org.gvsig.exportto.ExporttoServiceException;
 import org.gvsig.exportto.ExporttoServiceFinishAction;
+import org.gvsig.exportto.swing.spi.ExportGeometryUtils;
+import org.gvsig.exportto.swing.spi.ExportGeometryUtils.FixGeometryStatus;
 import org.gvsig.fmap.dal.DALLocator;
 import org.gvsig.fmap.dal.DataManager;
-import org.gvsig.fmap.dal.DataStoreProviderFactory;
 import org.gvsig.fmap.dal.DataTypes;
 import org.gvsig.fmap.dal.feature.EditableFeature;
 import org.gvsig.fmap.dal.feature.EditableFeatureAttributeDescriptor;
@@ -61,14 +62,6 @@
 
     private static final Logger logger = LoggerFactory.getLogger(ExporrtoJDBCService.class);
 
-    public static final int CHECK_NONE = 0;
-    public static final int CHECK_IF_CORRUPT = 1;
-    public static final int CHECK_IF_VALID = 2;
-
-    public static final int ACTION_SET_GEOMETRY_TO_NULL = 0;
-    public static final int ACTION_SKIP_FEATURE = 1;
-    public static final int ACTION_ABORT = 2;
-
     private ExporttoServiceFinishAction exporttoServiceFinishAction = null;
     private final ExporttoJDBCOptions options;
     private FeatureType targetFeatureType = null;
@@ -102,7 +95,7 @@
         
         boolean preferNotToUseNonNullRestrictions = factory.preferNotToUseNonNullRestrictions();
         
-        targetTempFeatureType = options.getSource().getDefaultFeatureType().getCopy();
+        targetTempFeatureType = options.getSourceFeatureType().getCopy();
         targetEditableFeatureType = targetTempFeatureType.getEditable();
 
         // Remove inherited primary keys from the data source and remove NotNull
@@ -204,7 +197,7 @@
 
             // ======================================
             // Reprojection
-            FeatureAttributeDescriptor geo_att = this.options.getSource().getDefaultFeatureType().getDefaultGeometryAttribute();
+            FeatureAttributeDescriptor geo_att = this.options.getSourceFeatureType().getDefaultGeometryAttribute();
             IProjection sourceProjection;
             ICoordTrans coord_trans = null;
             Geometry reproj_geom;
@@ -238,7 +231,7 @@
             openParams.setTable(this.options.getTableName());
             openParams.setCRS(targetProjection);
             openParams.setDefaultGeometryField(
-                    this.options.getSource().getDefaultFeatureType().getDefaultGeometryAttributeName()
+                    this.options.getSourceFeatureType().getDefaultGeometryAttributeName()
             );
             target = (FeatureStore) explorer.open(openParams);
 
@@ -290,63 +283,15 @@
                 }
 
                 Geometry geometry = targetFeature.getGeometry(targetGeometryIndex);
-                if (geometry != null) {
-                    switch (this.options.getGeometryChecks()) {
-                        case CHECK_IF_CORRUPT:
-                            geometryCheck = geometry.getValidationStatus();
-                            if (geometryCheck.getStatusCode() == Geometry.ValidationStatus.CURRUPTED) {
-                                switch (this.options.getGeometryChecksAction()) {
-                                    case ACTION_SET_GEOMETRY_TO_NULL:
-                                        targetFeature.setDefaultGeometry(null);
-                                        break;
-                                    case ACTION_SKIP_FEATURE:
-                                        continue;
-                                    case ACTION_ABORT:
-                                    default:
-                                        throw new InvalidGeometryException(targetFeature, geometryCheck.getMessage());
-                                }
-                            }
-
-                            break;
-
-                        case CHECK_IF_VALID:
-                            geometryCheck = geometry.getValidationStatus();
-                            if (!geometryCheck.isValid()) {
-                                Geometry g = null;
-                                if (this.options.getTryToFixGeometry()) {
-                                    g = geometry.makeValid();
-                                    if (g != null) {
-                                        targetFeature.setDefaultGeometry(g);
-                                    }
-                                }
-                                if (g == null) {
-                                    switch (this.options.getGeometryChecksAction()) {
-                                        case ACTION_SET_GEOMETRY_TO_NULL:
-                                            targetFeature.setDefaultGeometry(null);
-                                            break;
-                                        case ACTION_SKIP_FEATURE:
-                                            continue;
-                                        case ACTION_ABORT:
-                                        default:
-                                            throw new InvalidGeometryException(targetFeature, geometryCheck.getMessage());
-                                    }
-                                }
-                            }
-
-                            break;
-                        case CHECK_NONE:
-                        default:
-                            break;
-                    }
-                    // ================================================
-                    // Reprojection
-                    if (geo_att != null && coord_trans != null) {
-                        reproj_geom = targetFeature.getDefaultGeometry();
-                        reproj_geom = reproj_geom.cloneGeometry();
-                        reproj_geom.reProject(coord_trans);
-                        targetFeature.setDefaultGeometry(reproj_geom);
-                    }
-                    // ================================================
+                FixGeometryStatus check = ExportGeometryUtils.fixGeometry(options, coord_trans, geometry);
+                switch(check.getState()) {
+                    case FixGeometryStatus.STATE_OK:
+                        targetFeature.setDefaultGeometry(check.getGeometry());
+                        break;
+                    case FixGeometryStatus.STATE_SKIP:
+                        continue;
+                    case FixGeometryStatus.STATE_ABORT:
+                        throw new InvalidGeometryException(targetFeature, check.getMessage());
                 }
 
                 target.insert(targetFeature);
